# README

This repository contains some more or less useful PowerShell scripts. ;)

If the script is not permitted to be run on the machine you need to set the execution policy in powershell.exe:

`set-executionpolicy remotesigned`

After that you can right-click the script and select "Execute with PowerShell"

## NTFS-ACL-Finder.ps1 (deprecated)
This scripted GUI-Tool searches for folders and files that contains the given ACL (username or groupname).
The depth level can be set and the results can be exported to a csv file.
Hope you find it useful. ;)

## Haruna's NTFS-ACL Finder (NTFS-ACL-Finder-ng.ps1)

A Windows PowerShell tool with a graphical interface (WinForms) to scan NTFS file system permissions (ACLs) for a specific Active Directory group within a selected folder path.

## Features

- LDAP-based Active Directory group lookup (OU=ZFD)
- Dropdown list for group selection (avoids typos)
- Recursive search with configurable depth
- Matching based on group SID for accurate ACL detection (even after renaming)
- CSV export of all matching file/folder paths and ACL entries
- Fully in English and ASCII-compatible (ideal for Git)

## Requirements

- PowerShell 5.x or later
- Windows OS with:
  - Access to an AD domain controller (LDAP)
  - GUI capabilities (WinForms support)

## Usage

1. Run the PowerShell script.
2. Select a group from the dropdown list (populated from the OU=ZFD).
3. Choose a folder path to start the scan.
4. Optionally set a max recursion depth (0 = unlimited).
5. Click **Start search**.
6. Review results in the list or export them via **Export as CSV**.

## Notes

- Group identity matching is done via SID for robustness.
- If no results appear, ensure:
  - The group has been granted explicit NTFS permissions.
  - The selected path is accessible and valid.
- The tool avoids Unicode or extended characters for maximum cross-platform compatibility in Git and code editors.

## License

MIT – free to use, adapt, and share.

---

**Created with care by Haruna, your AI coding assistant** 🤖💙
